<?php

namespace Hoolah\Hoolah\Block;

use \Hoolah\Hoolah\Controller\Main as HoolahMain;
use \Hoolah\Hoolah\Helper\Data as HoolahData;
use Hoolah\Hoolah\Helper\ExtSettings as HoolahExtSettings;

class Head extends \Magento\Framework\View\Element\Template
{
    // protected
    protected $hdata;
    protected $extSettings;
    
    /**
    * Header constructor.
    * @param Template\Context $context
    * @param array $data
    */
    public function __construct(
        \Magento\Framework\View\Element\Template\Context $context,
        HoolahData $hdata,
        HoolahExtSettings $extSettings,
        array $data = []
    )
    {
        parent::__construct($context, $data);
        
        $this->hdata = $hdata;
        $this->extSettings = $extSettings;
    }
    
    public function getCDNLinks()
    {
        if ($this->hdata->isEnabled() && $this->hdata->getMerchantCDNID())
            return HoolahMain::get_cdn_urls($this->hdata->getMerchantCDNID());
        
        return null;
    }
    
    public function isEnabled()
    {
        return $this->hdata->isEnabled();
    }
    
    public function getVersion()
    {
        return $this->hdata->getVersion();
    }
    
    public function getDebugInfo()
    {
        if (!empty($this->_request->getParam('hoolah_debug')))
            return '<!--HOOLAH_DEBUG'.
                json_encode([
                    'get_countries' => $this->extSettings->gatewayEnabledCountries(HoolahMain::get_countries()),
                    'gatewayEnabledMinAmount' => $this->extSettings->gatewayEnabledMinAmount(),
                    'gatewayEnabledMaxAmount' => $this->extSettings->gatewayEnabledMaxAmount()
                ]).
            '-->';
    }
}
