<?php

namespace Hoolah\Hoolah\Model\Config\Source;

use \Hoolah\Hoolah\Controller\Main as HoolahMain;

class OperationMode implements \Magento\Framework\Option\ArrayInterface
{
    // const
    const MODE_PRODUCTION = 'Production';
    const MODE_PRODUCTION_SANDBOX = 'Production Sandbox';
    const MODE_DEV = 'Dev';
    const MODE_DEV_SANDBOX = 'Dev Sandbox';
    
    /**
     * {@inheritdoc}
     */
    public function toOptionArray()
    {
        if (HoolahMain::is_dev())
            return [
                [
                    'value' => self::MODE_PRODUCTION_SANDBOX,
                    'label' => __('Sandbox')
                ],
                [
                    'value' => self::MODE_PRODUCTION,
                    'label' => __('Production')
                ],
                [
                    'value' => self::MODE_DEV,
                    'label' => __(HOOLAH_DEV_NAME)
                ],
                [
                    'value' => self::MODE_DEV_SANDBOX,
                    'label' => __(HOOLAH_DEV_NAME.' Sandbox')
                ]
            ];
        else
            return [
                [
                    'value' => self::MODE_PRODUCTION_SANDBOX,
                    'label' => __('Sandbox')
                ],
                [
                    'value' => self::MODE_PRODUCTION,
                    'label' => __('Production')
                ]
            ];
    }
}
