<?php

namespace Hoolah\Hoolah\Model\Config\Structure\Element;

use \Magento\Config\Model\Config\Structure\Element\Group as OriginalGroup;

use \Hoolah\Hoolah\Controller\Main as HoolahMain;
use \Hoolah\Hoolah\Helper\Data as HoolahData;

class Group
{
    // const
    const HOOLAH_GROUP_MC = 'hoolah_mc';
    const HOOLAH_GROUP_CFM = 'hoolah_cfm';
    
    // protected
    protected $hdata;
    
    // public
    public function __construct(HoolahData $hdata) {
        $this->hdata = $hdata;
    }
    
    public function aroundSetData(OriginalGroup $subject, callable $proceed, array $data, $scope)
    {
        if (HoolahMain::is_dev())
            switch ($data['id'])
            {
                case self::HOOLAH_GROUP_MC:
                    $data['children']['dev_merchant_id']['label'] = __(HOOLAH_DEV_NAME.' Merchant ID');
                    $data['children']['dev_merchant_secret_test_mode']['label'] = __(HOOLAH_DEV_NAME.' Sandbox Merchant Secret');
                    $data['children']['dev_merchant_secret']['label'] = __(HOOLAH_DEV_NAME.' Merchant Secret');
                    break;
            }
        else
            switch ($data['id'])
            {
                case self::HOOLAH_GROUP_MC:
                    unset($data['children']['dev_merchant_id']);
                    unset($data['children']['dev_merchant_secret_test_mode']);
                    unset($data['children']['dev_merchant_secret']);
                    break;
            }
        
        if (!HOOLAH_ENABLE_EXTERNAL_ID_PREFIX && $data['id'] == self::HOOLAH_GROUP_CFM)
            unset($data['children']['external_id_prefix']);
        
        return $proceed($data, $scope);
    }
}
