<?php

namespace Hoolah\Hoolah\Test\Unit\Controller\Adminhtml;

use \Magento\Backend\App\Action;
use \Magento\Backend\App\Action\Context;
use \Magento\Framework\Controller\Result\JsonFactory;
use Magento\Framework\Controller\Result\Json;

use Hoolah\Hoolah\Controller\Adminhtml\System\Config\ValidateMerchant;

use PHPUnit\Framework\MockObject\MockObject;
use PHPUnit\Framework\TestCase;


class ValidateMerchantTest extends TestCase
{
    /**
     * @var testcontroller
     */
    private $controller;

    /**
     * @var Json|MockObject
     */
    private $resultJsonMock;

    /**
     * @var JsonFactory|MockObject
     */
    private $resultJsonFactoryMock;

    /**
     * @var contextMock|MockObject
     */
    private $contextMock ;

    protected function setUp(): void
    {
        $contextArgs = [];
        $this->contextMock = $this->getMockBuilder(
            '\Magento\Backend\App\Action\Context'
        )->disableOriginalConstructor()->setMethods(
            $contextArgs
        )->getMock();

        $this->resultJsonFactoryMock = $this->createMock(JsonFactory::class);

        $this->resultJsonMock = $this->createMock(Json::class);

        $this->resultJsonFactoryMock->expects($this->once())
            ->method('create')
            ->willReturn($this->resultJsonMock);

        $this->controller = new ValidateMerchant(
            $this->contextMock,
            $this->resultJsonFactoryMock
                );
    }

    /**
     * @return void
    */
    public function testExecuteNullCredential(): void
    {
        try{
            $this->controller->execute();
        }catch(Exception $e) {
            $this->resultJsonMock->expects($this->once())
            ->with([
                'merchant_id' => false,
                ])
            ->willReturn($this->resultJsonMock);
            $this->assertEquals('false', $e->getMessage());
            //$this->assertFalse( $returnVal );
        }
    }
}
