#!/usr/bin/env bash
cd /var/www/magento
echo "Check setup:upgrade status"
message=$(php7.3 bin/magento setup:db:status)

if [[ ${message:0:3} == "All" ]]; then
  echo "No setup upgrade - clear cache";
  php7.3 bin/magento cache:clean
else
  echo "Run setup:upgrade - maintenance mode"
  php7.3 bin/magento maintenance:enable
  php7.3 bin/magento setup:upgrade --keep-generated
  php7.3 bin/magento setup:di:compile
  php7.3 bin/magento maintenance:disable
  php7.3 bin/magento cache:flush
fi